/*

@author Andchir andchir@gmail.com

Smiles for InstantCMS 2.0+

*/

function insertAtCursor(myField, myValue) {
    if (document.selection) {
        myField.focus();
        sel = document.selection.createRange();
        sel.text = myValue;
    }
    else if (myField.selectionStart || myField.selectionStart == '0') {
        var startPos = myField.selectionStart;
        var endPos = myField.selectionEnd;
        myField.value = myField.value.substring(0, startPos)
            + myValue
            + myField.value.substring(endPos, myField.value.length);
    } else {
        myField.value += myValue;
    }
}

emojione.updateSmilesAll = function(){
    $('.comment .text, .preview_box').each(function(){
	var elem = this;
	emojione.imageType = 'png';
	emojione.sprites = true;
	$(elem).html( emojione.shortnameToImage( $(elem).html() ) );
    });
};

$( document ).bind( 'ready', emojione.updateSmilesAll );
$( document ).ajaxSuccess( emojione.updateSmilesAll );
$( document ).on('focus keyup', 'textarea.markItUpEditor', function( e ){
    var elem = this;
    if ( $( elem ).next('#emojione_smiles').size() == 0 ) {
	
	$('<div/>', {
	    "id": "emojione_smiles"
	}).insertAfter( elem );
	
	$( elem )
	    .emojioneArea({
		template: "<filters/><tabs/>",//<editor/>
		container: '#emojione_smiles',
		autoHideFilters: false,
		shortnames: true,
		hideSource: false
	    });
	
	$('#emojione_smiles')
	    .find('.emojionearea')
	    .removeClass('textarea markItUpEditor');
	
	$('#emojione_smiles')
	    .find('.emojionearea-filters')
	    .bind('click', function(){
		$('#emojione_smiles .emojibtn').unbind('click');
	    });
    }
});

$( document ).on('click', '.emojibtn', function(e){
    e.preventDefault();
    e.originalEvent.stopPropagation();
    var shortname = $( e.target ).data( 'name' ) || '';
    if( shortname ){
	insertAtCursor( $( 'textarea.markItUpEditor' ).get( 0 ), shortname );
    }
});
